"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || Object.assign || function(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
        s = arguments[i];
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
            t[p] = s[p];
    }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
//NPM Imports
var React = require("react");
var Row = /** @class */ (function (_super) {
    __extends(Row, _super);
    function Row(props) {
        var _this = _super.call(this, props) || this;
        _this.state = {
            error: undefined,
        };
        return _this;
    }
    Row.prototype.componentWillMount = function () {
        // console.log("BEGINNING OF ROW COMPONENT");
        if (this.props.cellWeights.length !== React.Children.count(this.props.children))
            this.setState({ error: "Cell Weights length does not match the number of child elements" });
    };
    Row.prototype.evaluateCellWeights = function () {
        var _this = this;
        // console.log(this.props.children);
        var weightTotal = 0;
        this.props.cellWeights.forEach(function (weight) { weightTotal = weightTotal + weight; });
        var newModifiedChildren = this.props.cellWeights.map(function (cellWeight, index) {
            var newStyle = __assign({}, _this.props.children[index].props.style, { "width": (cellWeight / weightTotal) * 100 + "%", "display": "inline-block" });
            (_this.props.borders) ? newStyle = __assign({}, newStyle, { "border": "solid 1px black" }) : undefined;
            return React.cloneElement(_this.props.children[index], { style: newStyle });
        });
        return newModifiedChildren;
    };
    Row.prototype.render = function () {
        if (this.state.error)
            return (React.createElement("div", null,
                "Error in Row Element: ",
                this.state.error));
        return (React.createElement("div", { className: "rowContent " + this.props.className, style: this.props.style }, this.evaluateCellWeights()));
    };
    return Row;
}(React.Component));
exports.default = Row;
